# Copyright (c) 2010, 2011, Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# GNU Affero General Public License version 3 (see the file LICENSE).

"""Tests of the TimedAction class."""

__metaclass__ = type

import datetime

import testtools

from timeline.nestingtimedaction import NestingTimedAction
from timeline.timeline import Timeline


class TestNestingTimedAction(testtools.TestCase):

    def test_finish_adds_action(self):
        timeline = Timeline()
        action = NestingTimedAction("Sending mail", None, timeline)
        action.finish()
        self.assertEqual(1, len(timeline.actions))
        self.assertEqual(datetime.timedelta(), timeline.actions[-1].duration)

    def test__init__sets_duration(self):
        action = NestingTimedAction("Sending mail", None)
        self.assertEqual(datetime.timedelta(), action.duration)
